let app;
let cnt = 0;
let jiki;
let tama01;
let enemy;
let enemy_anim;
let tama_move_flag = false;
let enemy_move_cnt = 0;
let enemy_move_vecX = 1;

window.addEventListener('load', function() {

  app = new PIXI.Application(800, 600, {backgroundColor : 0x212121});
  document.getElementById('pixiview').appendChild(app.view);

  /**
  * ローダー生成
  */
  PIXI.loader
  .add('jiki', 'images/jiki.png')
  .add('enemy', 'images/teki.png')
  .add('enemy_anim', 'images/teki_anim000.json')
  .add('tama01', 'images/tama01.png')
  .load(setup);

});


function setup(loader, resources) {

  //自機
  jiki = new PIXI.Sprite(resources.jiki.texture);
  jiki.anchor.x = 0.5;
  app.stage.addChild(jiki);
  jiki_init();


  //弾
  tama01 = new PIXI.Sprite(resources.tama01.texture);
  tama01.anchor.x = 0.5;
  app.stage.addChild(tama01);
  tama_init();


  //敵
  let frames = [];

  for( let i = 0; i < 5; i++ ) {
    frames[i] = PIXI.Texture.fromFrame('teki00000' + i);
  }
  enemy_anim = new PIXI.extras.AnimatedSprite(frames);
  enemy_anim.x = app.screen.width / 2;
  enemy_anim.y = 100;
  enemy_anim.anchor.set(0.5);
  enemy_anim.animationSpeed = 0.2;
  enemy_anim.loop = false;
  enemy_anim.onComplete = function () {
    enemy_init();
  }
  app.stage.addChild(enemy_anim);


  //フレーム毎処理登録
  app.ticker.add(function(delta) {
    jiki_move();
    tama_move();
    enemy_move()
  });

  //マウス左クリックの登録
  document.addEventListener('mousedown', mousedownEventHandler); 

}


function mousedownEventHandler() {
  tama_hassha ();
}

function tama_init() {
  tama_move_flag = false;
  tama01.x = -100;
}

function tama_hassha () {
  if( !tama_move_flag ) {
    tama_move_flag = true;
    tama01.x = jiki.x;
    tama01.y = jiki.y;
  }
}

function tama_move () {
  if( tama_move_flag && tama01.y > 1 ) {
    tama01.y -= 8;
    tama_hit();
  } else {
    if( tama_move_flag == true ) {
      tama_init();
    }
  }
}

function tama_hit() {
  let pt = tama01.position;
  
  if( enemy_anim.containsPoint(pt) ) {
     //hit hit!
     tama_init();
     enemy_anim.play();
  }
  
}

function enemy_init() {
  enemy_anim.x = app.screen.width / 2;
  enemy_anim.gotoAndStop(0);
}


function enemy_move() {
  enemy_move_cnt++;
  if( enemy_move_cnt > 100 ) {
    enemy_move_cnt = 0;
    let r = Math.random() - 0.5;
    if( r > 0 ) {
      enemy_move_vecX = 1;
    } else {
      enemy_move_vecX = -1;
    }
  }

  enemy_move_cnt = enemy_move_cnt % 3000;

  if( enemy_anim.x < 1 ) {
    enemy_anim.x = 2;
    enemy_move_vecX = 1;
    enemy_move_cnt = 0;
  }
  if( enemy_anim.x > 799 ) {
    enemy_anim.x = 798;
    enemy_move_vecX = -1;
    enemy_move_cnt = 0;
  }

  enemy_anim.x += enemy_move_vecX;

}

function jiki_init() {
  jiki.y = 500;
}

function jiki_move() {
  let mouseposition = app.renderer.plugins.interaction.mouse.global;
  jiki.x += ( mouseposition.x - jiki.x ) * 0.1;
}






